#include "aocolor.h"
#include <qcolor.h>

AOColor::AOColor(void)
{
	Name = "";
	Color = "";
	r = -1;
	g = -1;
	b = -1;
	Type = String;
}

AOColor::~AOColor(void)
{
}

void AOColor::setColor( QString color )
{
	Color = color;
	if( Color.left( 2 ) == "0x" )
	{
		QString hex = Color.section( 'x', -1 );
		if( hex.length() > 6 )
		{
			Type = Hex4;
			r = hex.mid( 2, 2 ).toInt( 0, 16 );
			g = hex.mid( 4, 2).toInt( 0, 16 );
			b = hex.right( 2 ).toInt( 0, 16 );
			qDebug( "AOColor::setColor(): Color %s is rgb4(%d,%d,%d) (%s,%s,%s)",
				Name.latin1(), r, g, b, hex.mid(2,2).latin1(), hex.mid(4,2).latin1(),
				hex.right(2).latin1() );
		}
		else
		{
			Type = Hex3;
			r = hex.left( 2 ).toInt( 0, 16 );
			g = hex.mid( 2, 2).toInt( 0, 16 );
			b = hex.right( 2 ).toInt( 0, 16 );
			qDebug( "AOColor::setColor(): Color %s is rgb3(%d,%d,%d) (%s,%s,%s)",
				Name.latin1(), r, g, b, hex.left(2).latin1(), hex.mid(4,2).latin1(),
				hex.right(2).latin1() );
		}
	}
	else
	{
		Type = String;
		qDebug( "AOColor::setColor(): Color %s is string(%s)",
			Name.latin1(), Color.latin1() );
	}
}

void AOColor::setColor( QColor color )
{
	if( Type == String )
		Type = Hex3;
	r = color.red();
	g = color.green();
	b = color.blue();

	QString str;
	str.sprintf( "%02x%02x%02x", r, g, b );

	if( Type == Hex3 )
		Color = QString( "0x" + str );
	else if( Type == Hex4 )
		Color = QString( "0x00" + str );

	qDebug( "AOColor::setColor(): Color %s is rgb(%d,%d,%d) (%s)",
		Name.latin1(), r, g, b, Color.latin1() );
}

QColor AOColor::color()
{
	switch( Type )
	{
	case String:
		return QColor( Color );
	case Hex3:
	case Hex4:
		return QColor( r, g, b );
	default:
		return QColor();
	}
}