#include <qapplication.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qtextstream.h>
#include <qstring.h>
#include <qstringlist.h>
#include "basedlg.h"

int main( int argc, char ** argv )
{
    QApplication app( argc, argv );

	QString AOPath;
	QFile CfgFile( "AOcrayon.cfg" );
	if( CfgFile.open( IO_ReadOnly ) )
	{
		QTextStream Config( &CfgFile );
		QString Buffer;

		while( !Config.eof() )
		{
			Buffer = Config.readLine();
			QStringList List( QStringList::split( " = ", Buffer ) );
			if( !List[0].compare( "AODir" ) )
			{
				AOPath = List[1];
			}
		}
		CfgFile.close();
	}

	BaseDlg dialog( AOPath, 0, 0, TRUE, Qt::WStyle_Customize | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu | Qt::WStyle_MinMax );
	app.setMainWidget( &dialog );

	if( dialog.exec() == QDialog::Accepted )
	{
		dialog.saveData();
		if( CfgFile.open( IO_WriteOnly ) )
		{
			QTextStream Config( &CfgFile );
			Config << "## AOcrayon Configuration ##\n";
			Config << "AODir = ";
			Config << dialog.getAOPath();
			CfgFile.close();
		}
	}

	return 0;
}
